NB. basic_system_tools.ijs
NB. basic_system_tools_2023_10_01.ijs

NB. Yuji Suda
NB. g.ysuda@gmail.com
NB. encoding code: UTF-8

NB. === basic system tools ===

NB. ====================================================================================================
NB. テキストファイルをスクリプトファイルとして読み込み（関数定義）
load_script =: 3 : 0
0!:3 <y
)

NB. ====================================================================================================
NB. read function script
read_fn_script =: 3 : 0
0!:3 <y
)

NB. ====================================================================================================
NB. read script
read_ijs_script =: 3 : 0  NB. read script file to define functions and globals
0!:3 <y
)

NB. ====================================================================================================
NB. exit from J
bye =: 3 : 0
2!:55 ''
)

NB. ====================================================================================================
NB. display x string to console(screen)
dispMsg =: 4 : 0
x 1!:2 <y
)

NB. ====================================================================================================
NB. pwd print working directory
pwd =: 3 : 0
1!:43 ''
)

NB. ====================================================================================================
NB. alternative definition
print_current_directory =: pwd

NB. ====================================================================================================
NB.  change directory
cddir =: 3 : 0
1!:44 y
)

NB. ====================================================================================================
change_dir =: cddir
cdir =: cddir

NB. ====================================================================================================
NB. mkdir
mkdir =: 3 : 0
1!:5 <y
)

NB. ====================================================================================================
NB.read from text file as a whole
read_from_file =: 3 : 0 
1!:1 <y
)

NB. ====================================================================================================
NB.read from text file as a whole (short command)
rff =: 3 : 0
1!:1 <y
)

NB. ====================================================================================================
NB.write string data x to y file
write_str_to_file =: 4 : 0
x 1!:2 <y
)

NB. ====================================================================================================
NB.write string data x to y file; (short command)
wtf =: 4 : 0
x 1!:2 <y
)

NB. ====================================================================================================
NB. テキストファイルへの追加
append_it =: 4 : 0
x 1!:3 <y
)

NB. ====================================================================================================
NB. directory check; same as windows command
dir =: 3 : 0
1!:0 <y
)

NB. ====================================================================================================
NB. remove file
rm =: 3 : 0
1!:55 <y
)

NB. ====================================================================================================
NB. file size
fs =: 3 : 0
1!:4 <y
)

NB. ====================================================================================================
NB. file size
file_size =: 3 : 0  NB. chekc file size
1!:4 <y
)

NB. ====================================================================================================
NB. screen output x string; same as dispMsg
NB. disp =: 4 : 0
NB. x 1!:2 <y
NB. )

NB. ====================================================================================================
NB. keyboard input string
keyin =: 3 : 0
1!:1 <1
)

NB. ====================================================================================================
exit =: 3 : 0
2!:55''
)

NB. ====================================================================================================
NB. screen output y; another function for screen out
screen_out =: 3 : 0
y 1!:2 >2
)

NB. ====================================================================================================
print =: screen_out

NB. ====================================================================================================
NB. good in mac/linux j not good in windows
get_home_directory =: 3 : 0
2!:0 'echo $HOME'
)

NB. ====================================================================================================
get_current_OS =: 3 : 0
9!:12 ''
NB. return 5 if mac or linux
NB. return 6 if windows
)

NB. ====================================================================================================
get_current_J_version =: 3 : 0
9!:14 ''
)

NB. ====================================================================================================
NB. scroll screen by arg number of lines
scroll_up_screen =: 3 : 0
rep =. 0
while. rep<y do.
  print CRLF
  rep =. rep + 1
end.
)

NB. ====================================================================================================
NB. 画面への出力(改行してから表示)
screen_out_preceded_by_CRLF =: 3 : 0 
NB. foreign conjunction による画面への文字列出力
NB. 文字列の出力の前にCRLF改行コードを送信する
v =. CRLF, y
v 1!:2 >2
)

NB. ====================================================================================================
NB. 現在時刻の取得
date_time =: 3 : 0
6!:0 ''
)

NB. ====================================================================================================
NB. 現在時刻 min and secの msecでの数値
NB. 処理時間をmsecで計測可能とする関数(J関数処理時間を評価する際に適宜使用)
NB. J関数の起動前と終了時に評価しその差分から所要時間を求める 
NB. 但し、現在時間の分と秒のみ使うので一時間以内であること
current_min_and_sec_in_msec =: 3 : 0
". 8j0 ": 1000 * 60 60 #. 4 5 { date_time ''
)

NB. ====================================================================================================
NB. on line realtme translation using translate_shell available in mac and linux
NB. no use of the translation for the time being
NB. print_with_eng_to_ja_translation =: 3 : 0
NB.if. (YOUR_OS -: 'mac') *. (TRANSLATE_SHELL_FLG = 1) do.
 NB.a_cmd =. '''', 'trans en:ja -b "', y, '"', ''''
 NB.print _1}.2!:0 ".a_cmd
NB.else.
 NB.print y
NB.end.
NB.)

NB. print2 =: print_with_eng_to_ja_translation

NB. ====== end of basic system tools ===
